*-----------------------------------------------------------
* Program    :RSA Chat Client v1.0
* Written by : Bobby Thompson
* Date       : Apr 17 2012
* Description: For EASy68K v5.3.5 or later
* Port 5003
* Send encrypted messages to server and decrypt incoming messages
*-----------------------------------------------------------
*original code from Echo v1.0 written by Charles kelly
*I added RSA encryption Algorithm and some memory clean up
*and converted the code to act as a low level encrypted chat
*I used Known values for encrypt key(n=29), decrypt key(s=569)
*and Mod (z=713): original primes to find those values were p=23 and q=31
;						KNOWN BUGS
****There are still sum bugs in the code such as needing to hit enter before
; typing a message after reieving a message and client must send first message or 
; server will not know where to send its messages
; notes may not be all correct do to many rewrights I lost track of some variables
; most should be right but you may incounter str1 instead of keybuf and the such

*	Clear Memory
ClEAR	MACRO
	lea		\1,A6
	while	\2 <GT> #0 do
	move.b	#0,(a6)+
	sub.b	#1,\2
	endw
	ENDM
* Display string
PRINT   MACRO
    ifnc    \1,A1           ; if first parameter is not A1
    lea     \1,A1           ; get string name from macro parameter
    endc
    move.b  #14,d0
    trap    #15             ; display string at (A1) without newline
    ENDM

* Display network error
PRINT_ERROR     MACRO
    movem.l d0/a1,-(sp)
    and.l   #$0ffff,d0          ; remove extended error code
    sub.l   #1,d0               ; make error code 0-7
    mulu.w  #netErrWidth,d0     ; calculate offset to error message
    lea     netErrors,a1
    lea     (a1,d0),a1
    PRINT   A1
    movem.l (sp)+,d0/a1
    ENDM


	ORG	$1000
START:				        ; first instruction of program

    ; check EASy68K version
    move.b  #32,d0
    move.b  #4,d1
    trap    #15             ; version number returned in D1.L
    if.l d1 <lo> #$050305 then.s    ; if older than version 5.3.5
        PRINT   versionError
        bra     halt
    endi

    ; ***** create client *****
    PRINT   promptIP
    move.b  #2,d0           ; read string 
    lea     remoteIP,a1
    trap    #15             ; read IP address as dotted quad nnn.nnn.nnn.nnn
    move.b  #100,d0         ; create client
    move.l  #(5003 << 16 + 0),d1    ; port 5003, UDP
    lea     remoteIP,a2
    trap    #15
    if.l D0 <ne> #0 then.s  ; if error
        PRINT_ERROR
        bra   halt
    endi
    ; display serverIP
    PRINT   serverIPmsg
    move.l  a2,a1
    PRINT   A1              ; print IP address at (A1)
    PRINT   CRLF
    ; display clientIP
    move.b  #105,d0
    lea     localIP,a2
    trap    #15             ; get local IP
    PRINT   clientIPmsg
    move.l  a2,a1
    PRINT   A1              ; print IP address at (A1)
    PRINT   CRLF


    ; send messages to server and display what is echoed back    
    lea     keybuf,a6
    clr.l   d7              ; input string size
loop
    move.l  #7,d0           ; check for keyboard input
    trap    #15             ; d1.b set too 1 if input pending else 0
    if.b d1 <eq> #1 then.s  ; if input pending
        move.b #5,d0        ; get keypress
        trap  #15
        if.b d1 <eq> #BS then.s ; if backspace
            sub.w   #1,d7       ; size -1
            if.w d7 <lt> #0 then.s  ; if buffer empty
                clr.l   d7
            else.s                  ; else, characters in buffer
                move.w  #0,-(a6)    ; erase from buffer
                move.w  #6,d0
                trap    #15         ; backspace
                move.w  #' ',d1
                trap    #15         ; erase char
                move.w  #BS,d1
                trap    #15         ; backspace
            endi
        else        ; else, not backspace
            if.b d1 <eq> #CR or.w d7 <hs> #80 then.s ; if Enter key or 80 char size limit
                if.b d7 <hs> #80 then.s ; if 80 chars limit                	
                    move.b  #14,d0
                    lea     CRLF,a1     ; display newline
                    trap    #15
                    bra		send		; if limit reached send data
                endi
send 			move.b  #102,d0     ; send data
				move.l  d7,d1       ; number of bytes to send
                lea     keybuf,a1   ; (a1) data to send
                trap    #15
                bra		clr
return          clr.l   d7          ; size = 0
                lea     keybuf,a6
            else
            	bra		ecrpt
save            add.w   #2,d7       ; size + 1
            endi
        endi
    endi
    
    ; check for receive
    move.b  #103,d0         ; receive data
    lea     netbuf,a1       ; receive buffer
    lea     remoteIP,a2     ; IP address of sender
    move.l  #BUFSIZE,d1     ; max chars to read
    trap    #15
    if.l d0 <eq> #0 and.l d1 <hi> #0 then.l  ; if characters received
        ; display incomming message
        bra		dcrptb
recieve move.b  #0,d0       ; display d1 chars with CR,LF
        lea     netbuf1,a1
        trap    #15
        move.w	#80,d2
        CLEAR	netbuf1,d2
        move.w	#80,d2
        CLEAR	netbuf,d2
    endi
    
    move.b  #23,d0          ; delay
    move.l  #1,d1           ; 1/100 second
    trap    #15
    
    bra     loop
;encryption start 
ecrpt	
	move.w	d1,d3	start of loop for encryption
	divu	z,d3
	swap	d3		x=a%z
	move.w 	d3,x
	clr.l	d3		clean up d3
	move.w	n,d4		set up loop without changing n
 while d4 <GT> #0 do	
    	divu	#2,d4		n=n/2
    	swap	d4		get remainder and run if statement if it is 1	
    		if.w d4 <eq> #1 then
    			move.w	result,d6
			mulu	x,d6		if(n%2==1)
			divu	z,d6		result=(result*x)%z
			clr.w	d6		clean up d6
			swap	d6
			move.w	d6,result
		endi
	move.w	x,d3
	mulu	x,d3		x=(x*x)%z
	divu	z,d3
	swap	d3
	move.w	d3,x
	clr.l	d3		clean out d3
	clr.w	d4		clean out remainder from d7		
	swap	d4		reset d7 to n/2 instead of remainder
  endw
end	move.w	d6,(a6)+	save encrypted letter as word in keybuf
	clr.l	d6
  	move	#1,result	reset result
  	bra	save
; decryption start

dcrptb	
	lea	netbuf1,a0		put netbuf in a0
	lea	netbuf,a4		put netbuf1 in a4.
dcrpt	
	move.w	(a4)+,d3	start of loop for decryption	
	cmp.b	#0,d3		check for end of string
	beq		end2		exit loop at end
	divu	z,d3
	swap	d3		x=a%z
	move.w 	d3,x
	clr.l	d3		clean up d3
	move.w	s,d4		set up loop without changing s
 while d4 <GT> #0 do	
    	divu	#2,d4		s=s/2
    	swap	d4		get remainder and run if statement if it is 1	
    	if.w d4 <eq> #1 then
    		move.w	result,d6
			mulu	x,d6		if(s%2==1)
			divu	z,d6		result=(result*x)%z
			clr.w	d6		clean up d6
			swap	d6
			move.w	d6,result
		endi
	move.w	x,d3
	mulu	x,d3		x=(x*x)%z
	divu	z,d3
	swap	d3
	move.w	d3,x
	clr.l	d3		clean out d3
	clr.w	d4		clean out remainder from d7		
	swap	d4		reset d7 to s/2 instead of remainder
  endw
  	move.b	d6,(a0)+	advance str1 to help find end of string
  	clr.l	d6
  	move	#1,result	reset result
  	bra	dcrpt
end2
	bra		recieve  
clr	move.w	d7,d6
	CLEAR	keybuf,d6
	bra		return
* Communications error
Fail:
    lea     ERROR,A1
    move.b  #13,d0
    trap    #15                 ; display error message

Halt 
    MOVE.B	#9,D0
	TRAP	#15		            ; halt simulator

* Constants
CR          equ $D              ; Carriage Return
LF          equ $A              ; Line Feed
BS          equ $8              ; Backspace
BUFSIZE     equ 80


* Variables and Strings
promptIP
        dc.b    'Enter IP address or name of server: ',0

serverIPmsg
        dc.b    'Server IP is: ',0
clientIPmsg
        dc.b    'Client IP is: ',0

CRLF    dc.b    CR,LF,0
        
        ds.w    0           ; force even
bufIP   ds.b    20

remoteIP    ds.b  BUFSIZE   ; remote IP as string 'aaa.bbb.ccc.ddd',0 or domain name
localIP     ds.b  16        ; local IP as string 'aaa.bbb.ccc.ddd',0
        
        ds.w    0           ; force word alignment
netbuf  ds.b    BUFSIZE     ; network data buffer
		ds.w	0
netbuf1	ds.w	BUFSIZE
        ds.w    0
keybuf  ds.w    BUFSIZE     ; keyboard input buffer
keybuf1	ds.w	BUFSIZE

n		dc.w	29
z		dc.w	713
result	dc.w	1
x		dc.w 	0
s		dc.w	569

ERROR           dc.b    CR,LF,'Communications Error',CR,LF,0
versionError    dc.b    'This program requires EASy68K v5.3.5 or newer.',CR,LF,0
portError       dc.b    'The specified port failed to initialize.',CR,LF,0
serverMnu       dc.b    'Enter server name: ',0
errorIPmsg      dc.b    'Error in IP address',CR,LF,0

* All netErrors messages must be 23 characters + 1 null for total of 24
netErrWidth equ 24
netErrors
        dc.b    'General network error  ',0
        dc.b    'Network init failed    ',0
        dc.b    'Invalid socket         ',0
        dc.b    'Get host by name failed',0
        dc.b    'Bind failed            ',0
        dc.b    'Connect failed         ',0
        dc.b    'Port alreay in use     ',0
        dc.b    'Domain not found       ',0

    END	START		; last line of source















































*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~4~
